<?php

namespace App\Http\Requests\Admin;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class MemberRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role, ['super_admin', 'admin', 'sub_admin']))
        {
            return true;
        }
        if(Auth::user()->hasModule('members'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=[
            'photo' => 'sometimes',
            'name'=> 'required|min:3',
            'phone'=> [
                "required",
                "numeric",
                "digits_between:11,14",
                Rule::unique('users')->ignore($this->member? $this->member->id : 0, 'id')
            ],
            'email'=> [
                'required',
                'email',
                Rule::unique('users')->ignore($this->member? $this->member->id : 0, 'id')
            ],
            'gender'=> 'required|in:male,female',
            'role'=> 'required|in:user,seller',
            'date_of_birth'=> 'required|date',
            'country_id'=> 'required|exists:countries,id',
            'city_id'=> 'required|exists:cities,id',
            'commission'=>'sometimes|required_if:role,==,seller',
        ];

        if ( !$this->member  ) {
            $rules['password'] ='required|confirmed';
        } else {
            $rules['password'] ='sometimes|confirmed';
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $field = metaFields('members');
        $local = getCurrentLocale();
        $attributes= [
            'name'=> $field[$local]['name'] ?? __('members.name'),
            'phone'=> $field[$local]['phone'] ?? __('members.phone'),
            'email'=> $field[$local]['email'] ?? __('members.email'),
            'photo'=> $field[$local]['photo'] ?? __('members.photo'),
            'gender'=> $field[$local]['gender'] ?? __('members.gender'),
            'date_of_birth'=> $field[$local]['date_of_birth'] ?? __('members.date_of_birth'),
            'country_id'=> $field[$local]['country_id'] ?? __('members.country_id'),
            'city_id'=> $field[$local]['city_id'] ?? __('members.city_id'),
            'commission' => __('members.commission'),
            'role'=> $field[$local]['role'] ?? __('members.role'),
            'password'=> $field[$local]['password'] ?? __('members.password'),
            'password_confirmation'=> $field[$local]['password_confirmation'] ?? __('members.password_confirmation'),
            'modules'=> $field[$local]['modules'] ?? __('members.modules'),
        ];
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
